
/* File:        org.molgenis.omx/model/Person.java
 * Generator:   org.molgenis.generators.DataTypeGen 4.0.0-testing
 *
 * THIS FILE HAS BEEN GENERATED, PLEASE DO NOT EDIT!
 */
 

package org.molgenis.omx.auth;

import java.util.LinkedHashSet;
import java.util.Set;

import org.molgenis.data.AttributeMetaData;
import org.molgenis.data.support.MapEntity;


/**
 * Person: 
				Person represents one or more people involved with an Investigation.
				This may include authors on a paper, lab personnel or PIs. Person
				has last name, firstname, mid initial, address, contact and email. A
				Person role is included to represent how a Person is involved with
				an investigation. For submission to repository purposes an allowed
				value is 'submitter' and the term is present in the MGED Ontology,
				an alternative use could represent job title. An Example from
				ArrayExpress is E-MTAB-506
				<a href="ftp://ftp.ebi.ac.uk/pub/databases/microarray/data/experiment/TABM/E-TABM-506/E-TABM-506.idf.txt">
					ftp://ftp.ebi.ac.uk/pub/databases/microarray/data/experiment/TABM/E-TABM-506/E-TABM-506.idf.txt.
				</a>
				.
				<br/>
				The FUGE equivalent to Person is FuGE::Person.
			.
 * @author MOLGENIS generator
 */
@javax.persistence.Entity
@javax.persistence.Table(name = "Person", uniqueConstraints={ @javax.persistence.UniqueConstraint( columnNames={ "Email" } ) }
)

@javax.xml.bind.annotation.XmlAccessorType(javax.xml.bind.annotation.XmlAccessType.FIELD)
@edu.umd.cs.findbugs.annotations.SuppressWarnings(value={"EI_EXPOSE_REP", "EI_EXPOSE_REP2"}, justification="Exposing internal representation is accepted")
public class Person extends org.molgenis.omx.observ.Characteristic implements org.molgenis.data.Entity, org.molgenis.omx.auth.PersonInterface
{
    /** default serial version ID */
    private static final long serialVersionUID = 1L;
    
    public final static String ENTITY_NAME = "Person";
    
	// fieldname constants
	public final static String ADDRESS = "Address";
	public final static String PHONE = "Phone";
	public final static String EMAIL = "Email";
	public final static String FAX = "Fax";
	public final static String TOLLFREEPHONE = "tollFreePhone";
	public final static String CITY = "City";
	public final static String COUNTRY = "Country";
	public final static String FIRSTNAME = "FirstName";
	public final static String MIDINITIALS = "MidInitials";
	public final static String LASTNAME = "LastName";
	public final static String TITLE = "Title";
	public final static String AFFILIATION = "Affiliation";
	public final static String DEPARTMENT = "Department";
	public final static String ROLES = "Roles";
	public final static String ID = "id";
	
	// member variables (including setters.getters for interface)
	public String getEntityName()
	{
		return ENTITY_NAME;
	}
	

	//The address of the Contact.[type=text]

	@javax.persistence.Lob
	@javax.persistence.Column(name="Address")
	
				

	private String address =  null;

	//The telephone number of the Contact including the suitable area codes.[type=string]

	@javax.persistence.Column(name="Phone", length=255)
	@javax.xml.bind.annotation.XmlElement(name="phone")
	
				

	private String phone =  null;

	//The email address of the Contact.[type=string]

	@javax.persistence.Column(name="Email", length=255)
	@javax.xml.bind.annotation.XmlElement(name="email")
	
				

	private String email =  null;

	//The fax number of the Contact.[type=string]

	@javax.persistence.Column(name="Fax", length=255)
	@javax.xml.bind.annotation.XmlElement(name="fax")
	
				

	private String fax =  null;

	//A toll free phone number for the Contact, including suitable area codes.[type=string]

	@javax.persistence.Column(name="tollFreePhone", length=255)
	@javax.xml.bind.annotation.XmlElement(name="tollFreePhone")
	
				

	private String tollFreePhone =  null;

	//Added from the old definition of MolgenisUser. City of this contact.[type=string]

	@javax.persistence.Column(name="City", length=255)
	@javax.xml.bind.annotation.XmlElement(name="city")
	
				

	private String city =  null;

	//Added from the old definition of MolgenisUser. Country of this contact.[type=string]

	@javax.persistence.Column(name="Country", length=255)
	@javax.xml.bind.annotation.XmlElement(name="country")
	
				

	private String country =  null;

	//[type=string]

	@javax.persistence.Column(name="FirstName", length=255)
	@javax.xml.bind.annotation.XmlElement(name="firstName")
	
				

	private String firstName =  null;

	//[type=string]

	@javax.persistence.Column(name="MidInitials", length=255)
	@javax.xml.bind.annotation.XmlElement(name="midInitials")
	
				

	private String midInitials =  null;

	//[type=string]

	@javax.persistence.Column(name="LastName", length=255)
	@javax.xml.bind.annotation.XmlElement(name="lastName")
	
				

	private String lastName =  null;

	//An academic title, e.g. Prof.dr, PhD[type=string]

	@javax.persistence.Column(name="Title", length=255)
	@javax.xml.bind.annotation.XmlElement(name="title")
	
				

	private String title =  null;

	//[type=xref]

    @javax.persistence.ManyToOne(fetch=javax.persistence.FetchType.EAGER /*cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}*/)
    @javax.persistence.JoinColumn(name="Affiliation")  
	
				

	private org.molgenis.omx.auth.Institute affiliation = null;

	//Added from the old definition of MolgenisUser. Department of this contact.[type=string]

	@javax.persistence.Column(name="Department", length=255)
	@javax.xml.bind.annotation.XmlElement(name="department")
	
				

	private String department =  null;

	//Indicate role of the contact, e.g. lab worker or PI. Changed from mref to xref in oct 2011.[type=xref]

    @javax.persistence.ManyToOne(fetch=javax.persistence.FetchType.EAGER /*cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}*/)
    @javax.persistence.JoinColumn(name="Roles")  
	
				

	private org.molgenis.omx.auth.PersonRole roles = null;

	//automatically generated internal id, only for internal use.[type=int]

	

	//constructors
	public Person()
	{
		//set the type for a new instance
		set__Type(this.getClass().getSimpleName());
	}
	
	//getters and setters
	/**
	 * Get the The address of the Contact..
	 * @return address.
	 */
	public String getAddress()
	{
		return this.address;
	}	
	
	/**
	 * Set the The address of the Contact..
	 * @param address
	 */
	public void setAddress( String address)
	{
		
		this.address = address;
	}

	

	/**
	 * Get the The telephone number of the Contact including the suitable area codes..
	 * @return phone.
	 */
	public String getPhone()
	{
		return this.phone;
	}	
	
	/**
	 * Set the The telephone number of the Contact including the suitable area codes..
	 * @param phone
	 */
	public void setPhone( String phone)
	{
		
		this.phone = phone;
	}

	

	/**
	 * Get the The email address of the Contact..
	 * @return email.
	 */
	public String getEmail()
	{
		return this.email;
	}	
	
	/**
	 * Set the The email address of the Contact..
	 * @param email
	 */
	public void setEmail( String email)
	{
		
		this.email = email;
	}

	

	/**
	 * Get the The fax number of the Contact..
	 * @return fax.
	 */
	public String getFax()
	{
		return this.fax;
	}	
	
	/**
	 * Set the The fax number of the Contact..
	 * @param fax
	 */
	public void setFax( String fax)
	{
		
		this.fax = fax;
	}

	

	/**
	 * Get the A toll free phone number for the Contact, including suitable area codes..
	 * @return tollFreePhone.
	 */
	public String getTollFreePhone()
	{
		return this.tollFreePhone;
	}	
	
	/**
	 * Set the A toll free phone number for the Contact, including suitable area codes..
	 * @param tollFreePhone
	 */
	public void setTollFreePhone( String tollFreePhone)
	{
		
		this.tollFreePhone = tollFreePhone;
	}

	

	/**
	 * Get the Added from the old definition of MolgenisUser. City of this contact..
	 * @return city.
	 */
	public String getCity()
	{
		return this.city;
	}	
	
	/**
	 * Set the Added from the old definition of MolgenisUser. City of this contact..
	 * @param city
	 */
	public void setCity( String city)
	{
		
		this.city = city;
	}

	

	/**
	 * Get the Added from the old definition of MolgenisUser. Country of this contact..
	 * @return country.
	 */
	public String getCountry()
	{
		return this.country;
	}	
	
	/**
	 * Set the Added from the old definition of MolgenisUser. Country of this contact..
	 * @param country
	 */
	public void setCountry( String country)
	{
		
		this.country = country;
	}

	

	/**
	 * Get the .
	 * @return firstName.
	 */
	public String getFirstName()
	{
		return this.firstName;
	}	
	
	/**
	 * Set the .
	 * @param firstName
	 */
	public void setFirstName( String firstName)
	{
		
		this.firstName = firstName;
	}

	

	/**
	 * Get the .
	 * @return midInitials.
	 */
	public String getMidInitials()
	{
		return this.midInitials;
	}	
	
	/**
	 * Set the .
	 * @param midInitials
	 */
	public void setMidInitials( String midInitials)
	{
		
		this.midInitials = midInitials;
	}

	

	/**
	 * Get the .
	 * @return lastName.
	 */
	public String getLastName()
	{
		return this.lastName;
	}	
	
	/**
	 * Set the .
	 * @param lastName
	 */
	public void setLastName( String lastName)
	{
		
		this.lastName = lastName;
	}

	

	/**
	 * Get the An academic title, e.g. Prof.dr, PhD.
	 * @return title.
	 */
	public String getTitle()
	{
		return this.title;
	}	
	
	/**
	 * Set the An academic title, e.g. Prof.dr, PhD.
	 * @param title
	 */
	public void setTitle( String title)
	{
		
		this.title = title;
	}

	

	/**
	 * Get the .
	 * @return affiliation.
	 */
	public org.molgenis.omx.auth.Institute getAffiliation()
	{
		return this.affiliation;
	}	
	
	/**
	 * Set the .
	 * @param affiliation
	 */
	public void setAffiliation( org.molgenis.omx.auth.Institute affiliation)
	{
		
		this.affiliation = affiliation;
	}

	

	/**
	 * Get the Added from the old definition of MolgenisUser. Department of this contact..
	 * @return department.
	 */
	public String getDepartment()
	{
		return this.department;
	}	
	
	/**
	 * Set the Added from the old definition of MolgenisUser. Department of this contact..
	 * @param department
	 */
	public void setDepartment( String department)
	{
		
		this.department = department;
	}

	

	/**
	 * Get the Indicate role of the contact, e.g. lab worker or PI. Changed from mref to xref in oct 2011..
	 * @return roles.
	 */
	public org.molgenis.omx.auth.PersonRole getRoles()
	{
		return this.roles;
	}	
	
	/**
	 * Set the Indicate role of the contact, e.g. lab worker or PI. Changed from mref to xref in oct 2011..
	 * @param roles
	 */
	public void setRoles( org.molgenis.omx.auth.PersonRole roles)
	{
		
		this.roles = roles;
	}

	

	

	


	/**
	 * Generic getter. Get the property by using the name.
	 */
	@Override
	public Object get(String name)
	{
		name = name.toLowerCase();
		if (name.equals("id"))
			return getId();
		if (name.equals("identifier"))
			return getIdentifier();
		if (name.equals("name"))
			return getName();
		if (name.equals("__type"))
			return get__Type();
		if(name.equals("__type_label"))
			return get__TypeLabel();			
		if (name.equals("description"))
			return getDescription();
		if (name.equals("address"))
			return getAddress();
		if (name.equals("phone"))
			return getPhone();
		if (name.equals("email"))
			return getEmail();
		if (name.equals("fax"))
			return getFax();
		if (name.equals("tollfreephone"))
			return getTollFreePhone();
		if (name.equals("city"))
			return getCity();
		if (name.equals("country"))
			return getCountry();
		if (name.equals("firstname"))
			return getFirstName();
		if (name.equals("midinitials"))
			return getMidInitials();
		if (name.equals("lastname"))
			return getLastName();
		if (name.equals("title"))
			return getTitle();
		if (name.equals("affiliation"))
			return getAffiliation();
		if (name.equals("department"))
			return getDepartment();
		if (name.equals("roles"))
			return getRoles();
		return null;
	}	
	
	@Override
	public void set(org.molgenis.data.Entity entity, boolean strict)
	{
		//set Id
		// query formal name, else lowercase name
		if(entity.getInt("id") != null) this.setId(entity.getInt("id"));
		else if(entity.getInt("id") != null) this.setId(entity.getInt("id"));
		else if(strict) this.setId(entity.getInt("id")); // setting null is not an option due to function overloading
		if( entity.getInt("person_id") != null) this.setId(entity.getInt("person_id"));
		else if( entity.getInt("Person_id") != null) this.setId(entity.getInt("Person_id"));
		//set Identifier
		// query formal name, else lowercase name
		if(entity.getString("identifier") != null) this.setIdentifier(entity.getString("identifier"));
		else if(entity.getString("Identifier") != null) this.setIdentifier(entity.getString("Identifier"));
		else if(strict) this.setIdentifier(entity.getString("identifier")); // setting null is not an option due to function overloading
		if( entity.getString("person_identifier") != null) this.setIdentifier(entity.getString("person_identifier"));
		else if( entity.getString("Person_Identifier") != null) this.setIdentifier(entity.getString("Person_Identifier"));
		//set Name
		// query formal name, else lowercase name
		if(entity.getString("name") != null) this.setName(entity.getString("name"));
		else if(entity.getString("Name") != null) this.setName(entity.getString("Name"));
		else if(strict) this.setName(entity.getString("name")); // setting null is not an option due to function overloading
		if( entity.getString("person_name") != null) this.setName(entity.getString("person_name"));
		else if( entity.getString("Person_Name") != null) this.setName(entity.getString("Person_Name"));
		//set __Type
		// query formal name, else lowercase name
		if(entity.getString("__type") != null) this.set__Type(entity.getString("__type"));
		else if(entity.getString("__Type") != null) this.set__Type(entity.getString("__Type"));
		else if(strict) this.set__Type(entity.getString("__type")); // setting null is not an option due to function overloading
		if( entity.getString("person___type") != null) this.set__Type(entity.getString("person___type"));
		else if( entity.getString("Person___Type") != null) this.set__Type(entity.getString("Person___Type"));
		//set Description
		// query formal name, else lowercase name
		if(entity.getString("description") != null) this.setDescription(entity.getString("description"));
		else if(entity.getString("description") != null) this.setDescription(entity.getString("description"));
		else if(strict) this.setDescription(entity.getString("description")); // setting null is not an option due to function overloading
		if( entity.getString("person_description") != null) this.setDescription(entity.getString("person_description"));
		else if( entity.getString("Person_description") != null) this.setDescription(entity.getString("Person_description"));
		//set Address
		// query formal name, else lowercase name
		if(entity.getString("address") != null) this.setAddress(entity.getString("address"));
		else if(entity.getString("Address") != null) this.setAddress(entity.getString("Address"));
		else if(strict) this.setAddress(entity.getString("address")); // setting null is not an option due to function overloading
		if( entity.getString("person_address") != null) this.setAddress(entity.getString("person_address"));
		else if( entity.getString("Person_Address") != null) this.setAddress(entity.getString("Person_Address"));
		//set Phone
		// query formal name, else lowercase name
		if(entity.getString("phone") != null) this.setPhone(entity.getString("phone"));
		else if(entity.getString("Phone") != null) this.setPhone(entity.getString("Phone"));
		else if(strict) this.setPhone(entity.getString("phone")); // setting null is not an option due to function overloading
		if( entity.getString("person_phone") != null) this.setPhone(entity.getString("person_phone"));
		else if( entity.getString("Person_Phone") != null) this.setPhone(entity.getString("Person_Phone"));
		//set Email
		// query formal name, else lowercase name
		if(entity.getString("email") != null) this.setEmail(entity.getString("email"));
		else if(entity.getString("Email") != null) this.setEmail(entity.getString("Email"));
		else if(strict) this.setEmail(entity.getString("email")); // setting null is not an option due to function overloading
		if( entity.getString("person_email") != null) this.setEmail(entity.getString("person_email"));
		else if( entity.getString("Person_Email") != null) this.setEmail(entity.getString("Person_Email"));
		//set Fax
		// query formal name, else lowercase name
		if(entity.getString("fax") != null) this.setFax(entity.getString("fax"));
		else if(entity.getString("Fax") != null) this.setFax(entity.getString("Fax"));
		else if(strict) this.setFax(entity.getString("fax")); // setting null is not an option due to function overloading
		if( entity.getString("person_fax") != null) this.setFax(entity.getString("person_fax"));
		else if( entity.getString("Person_Fax") != null) this.setFax(entity.getString("Person_Fax"));
		//set TollFreePhone
		// query formal name, else lowercase name
		if(entity.getString("tollfreephone") != null) this.setTollFreePhone(entity.getString("tollfreephone"));
		else if(entity.getString("tollFreePhone") != null) this.setTollFreePhone(entity.getString("tollFreePhone"));
		else if(strict) this.setTollFreePhone(entity.getString("tollfreephone")); // setting null is not an option due to function overloading
		if( entity.getString("person_tollfreephone") != null) this.setTollFreePhone(entity.getString("person_tollfreephone"));
		else if( entity.getString("Person_tollFreePhone") != null) this.setTollFreePhone(entity.getString("Person_tollFreePhone"));
		//set City
		// query formal name, else lowercase name
		if(entity.getString("city") != null) this.setCity(entity.getString("city"));
		else if(entity.getString("City") != null) this.setCity(entity.getString("City"));
		else if(strict) this.setCity(entity.getString("city")); // setting null is not an option due to function overloading
		if( entity.getString("person_city") != null) this.setCity(entity.getString("person_city"));
		else if( entity.getString("Person_City") != null) this.setCity(entity.getString("Person_City"));
		//set Country
		// query formal name, else lowercase name
		if(entity.getString("country") != null) this.setCountry(entity.getString("country"));
		else if(entity.getString("Country") != null) this.setCountry(entity.getString("Country"));
		else if(strict) this.setCountry(entity.getString("country")); // setting null is not an option due to function overloading
		if( entity.getString("person_country") != null) this.setCountry(entity.getString("person_country"));
		else if( entity.getString("Person_Country") != null) this.setCountry(entity.getString("Person_Country"));
		//set FirstName
		// query formal name, else lowercase name
		if(entity.getString("firstname") != null) this.setFirstName(entity.getString("firstname"));
		else if(entity.getString("FirstName") != null) this.setFirstName(entity.getString("FirstName"));
		else if(strict) this.setFirstName(entity.getString("firstname")); // setting null is not an option due to function overloading
		if( entity.getString("person_firstname") != null) this.setFirstName(entity.getString("person_firstname"));
		else if( entity.getString("Person_FirstName") != null) this.setFirstName(entity.getString("Person_FirstName"));
		//set MidInitials
		// query formal name, else lowercase name
		if(entity.getString("midinitials") != null) this.setMidInitials(entity.getString("midinitials"));
		else if(entity.getString("MidInitials") != null) this.setMidInitials(entity.getString("MidInitials"));
		else if(strict) this.setMidInitials(entity.getString("midinitials")); // setting null is not an option due to function overloading
		if( entity.getString("person_midinitials") != null) this.setMidInitials(entity.getString("person_midinitials"));
		else if( entity.getString("Person_MidInitials") != null) this.setMidInitials(entity.getString("Person_MidInitials"));
		//set LastName
		// query formal name, else lowercase name
		if(entity.getString("lastname") != null) this.setLastName(entity.getString("lastname"));
		else if(entity.getString("LastName") != null) this.setLastName(entity.getString("LastName"));
		else if(strict) this.setLastName(entity.getString("lastname")); // setting null is not an option due to function overloading
		if( entity.getString("person_lastname") != null) this.setLastName(entity.getString("person_lastname"));
		else if( entity.getString("Person_LastName") != null) this.setLastName(entity.getString("Person_LastName"));
		//set Title
		// query formal name, else lowercase name
		if(entity.getString("title") != null) this.setTitle(entity.getString("title"));
		else if(entity.getString("Title") != null) this.setTitle(entity.getString("Title"));
		else if(strict) this.setTitle(entity.getString("title")); // setting null is not an option due to function overloading
		if( entity.getString("person_title") != null) this.setTitle(entity.getString("person_title"));
		else if( entity.getString("Person_Title") != null) this.setTitle(entity.getString("Person_Title"));
		//set Affiliation
		// query formal name, else lowercase name
		if( entity.get("Affiliation") != null) { 
			this.setAffiliation((org.molgenis.omx.auth.Institute)entity.get("Affiliation"));				
		}
		else if( entity.get("affiliation") != null) { 
			this.setAffiliation((org.molgenis.omx.auth.Institute)entity.get("affiliation"));				
		}
		else if( entity.get("Person_Affiliation") != null) { 
			this.setAffiliation((org.molgenis.omx.auth.Institute)entity.get("Person_Affiliation"));				
		}
		else if( entity.get("person_affiliation") != null) { 
			this.setAffiliation((org.molgenis.omx.auth.Institute)entity.get("Person_Affiliation"));				
		}
		//set Department
		// query formal name, else lowercase name
		if(entity.getString("department") != null) this.setDepartment(entity.getString("department"));
		else if(entity.getString("Department") != null) this.setDepartment(entity.getString("Department"));
		else if(strict) this.setDepartment(entity.getString("department")); // setting null is not an option due to function overloading
		if( entity.getString("person_department") != null) this.setDepartment(entity.getString("person_department"));
		else if( entity.getString("Person_Department") != null) this.setDepartment(entity.getString("Person_Department"));
		//set Roles
		// query formal name, else lowercase name
		if( entity.get("Roles") != null) { 
			this.setRoles((org.molgenis.omx.auth.PersonRole)entity.get("Roles"));				
		}
		else if( entity.get("roles") != null) { 
			this.setRoles((org.molgenis.omx.auth.PersonRole)entity.get("roles"));				
		}
		else if( entity.get("Person_Roles") != null) { 
			this.setRoles((org.molgenis.omx.auth.PersonRole)entity.get("Person_Roles"));				
		}
		else if( entity.get("person_roles") != null) { 
			this.setRoles((org.molgenis.omx.auth.PersonRole)entity.get("Person_Roles"));				
		}
	}
	
	@Override
	public String toString()
	{
		return this.toString(false);
	}
	
	public String toString(boolean verbose)
	{
		StringBuilder sb = new StringBuilder("Person(");
		sb.append("id='" + getId()+"' ");	
		sb.append("identifier='" + getIdentifier()+"' ");	
		sb.append("name='" + getName()+"' ");	
		sb.append("__Type='" + get__Type()+"' ");	
		sb.append("description='" + getDescription()+"' ");	
		sb.append("address='" + getAddress()+"' ");	
		sb.append("phone='" + getPhone()+"' ");	
		sb.append("email='" + getEmail()+"' ");	
		sb.append("fax='" + getFax()+"' ");	
		sb.append("tollFreePhone='" + getTollFreePhone()+"' ");	
		sb.append("city='" + getCity()+"' ");	
		sb.append("country='" + getCountry()+"' ");	
		sb.append("firstName='" + getFirstName()+"' ");	
		sb.append("midInitials='" + getMidInitials()+"' ");	
		sb.append("lastName='" + getLastName()+"' ");	
		sb.append("title='" + getTitle()+"' ");	
		sb.append("affiliation='" + getAffiliation()+"' ");	
		sb.append("department='" + getDepartment()+"' ");	
		sb.append("roles='" + getRoles()+"'");	
		sb.append(");");
		return sb.toString();
	}

	@Override
	public Integer getIdValue()
	{
		return getId();
	}		
	

	@Override
	public Iterable<String> getAttributeNames()
	{
		Set<String> attributeNames = new LinkedHashSet<String>();
		for (AttributeMetaData attr : new PersonMetaData().getAttributes())
		{
			attributeNames.add(attr.getName());
		}

		return attributeNames;
	}
	
	@Override
	public java.util.List<String> getLabelAttributeNames()
	{
		java.util.List<String> result = new java.util.ArrayList<String>();
		result.add("Name");
		return result;
	}

	@Override
	public void set(String attributeName, Object value)
	{
		set(new MapEntity(attributeName, value), false);
	}

	@Override
	public boolean equals(Object obj)
	{
		if (this == obj) return true;
		if (obj == null) return false;
		if (!super.equals(obj)) return false;
		if (getClass() != obj.getClass()) return false;
		Person other = (Person) obj;
		if (email == null)
		{
			if (other.email != null) return false;
		}
		else if (!email.equals(other.email)) return false;
		return true;
	}
	
	@Override
	public int hashCode()
	{
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((email == null) ? 0 : email.hashCode());
		return result;
	}
	
	@Override
	public org.molgenis.data.EntityMetaData getEntityMetaData()
	{
		return new PersonMetaData();
	}
}
