
/* File:        org.molgenis.omx/model/Category.java
 * Generator:   org.molgenis.generators.DataTypeGen 4.0.0-testing
 *
 * THIS FILE HAS BEEN GENERATED, PLEASE DO NOT EDIT!
 */
 

package org.molgenis.omx.observ;

import java.util.LinkedHashSet;
import java.util.Set;

import org.molgenis.data.AttributeMetaData;
import org.molgenis.data.support.MapEntity;


/**
 * Category: Category is partOf ObservableFeature to define
				categories for an
				ObservableFeature, such as the categorical answer
				codes that are often used in Questionaires.
				For example the ObservableFeature 'sex' has {code_string = 1,
				label=male} and {code_string
				= 2, label=female}. Category can be
				linked to well-defined ontology terms via the
				ontologyReference.
				Category extends ObservationElement such that it
				can be referenced by
				ObservedValue.value.
				The Category class maps to METABASE::Category
			.
 * @author MOLGENIS generator
 */
@javax.persistence.Entity
@javax.persistence.Table(name = "Category"
)

@javax.xml.bind.annotation.XmlAccessorType(javax.xml.bind.annotation.XmlAccessType.FIELD)
@edu.umd.cs.findbugs.annotations.SuppressWarnings(value={"EI_EXPOSE_REP", "EI_EXPOSE_REP2"}, justification="Exposing internal representation is accepted")
public class Category extends org.molgenis.omx.observ.Characteristic implements org.molgenis.data.Entity
{
    /** default serial version ID */
    private static final long serialVersionUID = 1L;
    
    public final static String ENTITY_NAME = "Category";
    
	// fieldname constants
	public final static String OBSERVABLEFEATURE = "observableFeature";
	public final static String VALUECODE = "valueCode";
	public final static String DEFINITION = "definition";
	public final static String ISMISSING = "isMissing";
	public final static String ID = "id";
	
	// member variables (including setters.getters for interface)
	public String getEntityName()
	{
		return ENTITY_NAME;
	}
	

	//The Measurement these permitted values are part of.[type=xref]

    @javax.persistence.ManyToOne(fetch=javax.persistence.FetchType.EAGER /*cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}*/)
    @javax.persistence.JoinColumn(name="observableFeature", nullable=false)  
	
				

	@javax.validation.constraints.NotNull
	private org.molgenis.omx.observ.ObservableFeature observableFeature = null;

	//The value used to store this category in ObservedValue. For example '1', '2'.[type=string]

	@javax.persistence.Column(name="valueCode", length=255)
	@javax.xml.bind.annotation.XmlElement(name="valueCode")
	
				

	private String valueCode =  null;

	//The category that is being measured in a specific way.[type=xref]

    @javax.persistence.ManyToOne(fetch=javax.persistence.FetchType.EAGER /*cascade={javax.persistence.CascadeType.MERGE, javax.persistence.CascadeType.PERSIST, javax.persistence.CascadeType.REFRESH}*/)
    @javax.persistence.JoinColumn(name="definition")  
	
				

	private org.molgenis.omx.observ.target.OntologyTerm definition = null;

	//whether this value should be treated as missing value.[type=bool]

	@javax.persistence.Column(name="isMissing", nullable=false)
	@javax.xml.bind.annotation.XmlElement(name="isMissing")
	
				

	@javax.validation.constraints.NotNull
	private Boolean isMissing =  false;

	//automatically generated internal id, only for internal use.[type=int]

	

	//constructors
	public Category()
	{
		//set the type for a new instance
		set__Type(this.getClass().getSimpleName());
	}
	
	//getters and setters
	/**
	 * Get the The Measurement these permitted values are part of..
	 * @return observableFeature.
	 */
	public org.molgenis.omx.observ.ObservableFeature getObservableFeature()
	{
		return this.observableFeature;
	}	
	
	/**
	 * Set the The Measurement these permitted values are part of..
	 * @param observableFeature
	 */
	public void setObservableFeature( org.molgenis.omx.observ.ObservableFeature observableFeature)
	{
		
		this.observableFeature = observableFeature;
	}

	

	/**
	 * Get the The value used to store this category in ObservedValue. For example '1', '2'..
	 * @return valueCode.
	 */
	public String getValueCode()
	{
		return this.valueCode;
	}	
	
	/**
	 * Set the The value used to store this category in ObservedValue. For example '1', '2'..
	 * @param valueCode
	 */
	public void setValueCode( String valueCode)
	{
		
		this.valueCode = valueCode;
	}

	

	/**
	 * Get the The category that is being measured in a specific way..
	 * @return definition.
	 */
	public org.molgenis.omx.observ.target.OntologyTerm getDefinition()
	{
		return this.definition;
	}	
	
	/**
	 * Set the The category that is being measured in a specific way..
	 * @param definition
	 */
	public void setDefinition( org.molgenis.omx.observ.target.OntologyTerm definition)
	{
		
		this.definition = definition;
	}

	

	/**
	 * Get the whether this value should be treated as missing value..
	 * @return isMissing.
	 */
	public Boolean getIsMissing()
	{
		return this.isMissing;
	}	
	
	/**
	 * Set the whether this value should be treated as missing value..
	 * @param isMissing
	 */
	public void setIsMissing( Boolean isMissing)
	{
		
		this.isMissing = isMissing;
	}

	

	

	


	/**
	 * Generic getter. Get the property by using the name.
	 */
	@Override
	public Object get(String name)
	{
		name = name.toLowerCase();
		if (name.equals("id"))
			return getId();
		if (name.equals("identifier"))
			return getIdentifier();
		if (name.equals("name"))
			return getName();
		if (name.equals("__type"))
			return get__Type();
		if(name.equals("__type_label"))
			return get__TypeLabel();			
		if (name.equals("description"))
			return getDescription();
		if (name.equals("observablefeature"))
			return getObservableFeature();
		if (name.equals("valuecode"))
			return getValueCode();
		if (name.equals("definition"))
			return getDefinition();
		if (name.equals("ismissing"))
			return getIsMissing();
		return null;
	}	
	
	@Override
	public void set(org.molgenis.data.Entity entity, boolean strict)
	{
		//set Id
		// query formal name, else lowercase name
		if(entity.getInt("id") != null) this.setId(entity.getInt("id"));
		else if(entity.getInt("id") != null) this.setId(entity.getInt("id"));
		else if(strict) this.setId(entity.getInt("id")); // setting null is not an option due to function overloading
		if( entity.getInt("category_id") != null) this.setId(entity.getInt("category_id"));
		else if( entity.getInt("Category_id") != null) this.setId(entity.getInt("Category_id"));
		//set Identifier
		// query formal name, else lowercase name
		if(entity.getString("identifier") != null) this.setIdentifier(entity.getString("identifier"));
		else if(entity.getString("Identifier") != null) this.setIdentifier(entity.getString("Identifier"));
		else if(strict) this.setIdentifier(entity.getString("identifier")); // setting null is not an option due to function overloading
		if( entity.getString("category_identifier") != null) this.setIdentifier(entity.getString("category_identifier"));
		else if( entity.getString("Category_Identifier") != null) this.setIdentifier(entity.getString("Category_Identifier"));
		//set Name
		// query formal name, else lowercase name
		if(entity.getString("name") != null) this.setName(entity.getString("name"));
		else if(entity.getString("Name") != null) this.setName(entity.getString("Name"));
		else if(strict) this.setName(entity.getString("name")); // setting null is not an option due to function overloading
		if( entity.getString("category_name") != null) this.setName(entity.getString("category_name"));
		else if( entity.getString("Category_Name") != null) this.setName(entity.getString("Category_Name"));
		//set __Type
		// query formal name, else lowercase name
		if(entity.getString("__type") != null) this.set__Type(entity.getString("__type"));
		else if(entity.getString("__Type") != null) this.set__Type(entity.getString("__Type"));
		else if(strict) this.set__Type(entity.getString("__type")); // setting null is not an option due to function overloading
		if( entity.getString("category___type") != null) this.set__Type(entity.getString("category___type"));
		else if( entity.getString("Category___Type") != null) this.set__Type(entity.getString("Category___Type"));
		//set Description
		// query formal name, else lowercase name
		if(entity.getString("description") != null) this.setDescription(entity.getString("description"));
		else if(entity.getString("description") != null) this.setDescription(entity.getString("description"));
		else if(strict) this.setDescription(entity.getString("description")); // setting null is not an option due to function overloading
		if( entity.getString("category_description") != null) this.setDescription(entity.getString("category_description"));
		else if( entity.getString("Category_description") != null) this.setDescription(entity.getString("Category_description"));
		//set ObservableFeature
		// query formal name, else lowercase name
		if( entity.get("observableFeature") != null) { 
			this.setObservableFeature((org.molgenis.omx.observ.ObservableFeature)entity.get("observableFeature"));				
		}
		else if( entity.get("observablefeature") != null) { 
			this.setObservableFeature((org.molgenis.omx.observ.ObservableFeature)entity.get("observablefeature"));				
		}
		else if( entity.get("Category_observableFeature") != null) { 
			this.setObservableFeature((org.molgenis.omx.observ.ObservableFeature)entity.get("Category_observableFeature"));				
		}
		else if( entity.get("category_observablefeature") != null) { 
			this.setObservableFeature((org.molgenis.omx.observ.ObservableFeature)entity.get("Category_observableFeature"));				
		}
		//set ValueCode
		// query formal name, else lowercase name
		if(entity.getString("valuecode") != null) this.setValueCode(entity.getString("valuecode"));
		else if(entity.getString("valueCode") != null) this.setValueCode(entity.getString("valueCode"));
		else if(strict) this.setValueCode(entity.getString("valuecode")); // setting null is not an option due to function overloading
		if( entity.getString("category_valuecode") != null) this.setValueCode(entity.getString("category_valuecode"));
		else if( entity.getString("Category_valueCode") != null) this.setValueCode(entity.getString("Category_valueCode"));
		//set Definition
		// query formal name, else lowercase name
		if( entity.get("definition") != null) { 
			this.setDefinition((org.molgenis.omx.observ.target.OntologyTerm)entity.get("definition"));				
		}
		else if( entity.get("definition") != null) { 
			this.setDefinition((org.molgenis.omx.observ.target.OntologyTerm)entity.get("definition"));				
		}
		else if( entity.get("Category_definition") != null) { 
			this.setDefinition((org.molgenis.omx.observ.target.OntologyTerm)entity.get("Category_definition"));				
		}
		else if( entity.get("category_definition") != null) { 
			this.setDefinition((org.molgenis.omx.observ.target.OntologyTerm)entity.get("Category_definition"));				
		}
		//set IsMissing
		// query formal name, else lowercase name
		if(entity.getBoolean("ismissing") != null) this.setIsMissing(entity.getBoolean("ismissing"));
		else if(entity.getBoolean("isMissing") != null) this.setIsMissing(entity.getBoolean("isMissing"));
		else if(strict) this.setIsMissing(entity.getBoolean("ismissing")); // setting null is not an option due to function overloading
		if( entity.getBoolean("category_ismissing") != null) this.setIsMissing(entity.getBoolean("category_ismissing"));
		else if( entity.getBoolean("Category_isMissing") != null) this.setIsMissing(entity.getBoolean("Category_isMissing"));
	}
	
	@Override
	public String toString()
	{
		return this.toString(false);
	}
	
	public String toString(boolean verbose)
	{
		StringBuilder sb = new StringBuilder("Category(");
		sb.append("id='" + getId()+"' ");	
		sb.append("identifier='" + getIdentifier()+"' ");	
		sb.append("name='" + getName()+"' ");	
		sb.append("__Type='" + get__Type()+"' ");	
		sb.append("description='" + getDescription()+"' ");	
		sb.append("observableFeature='" + getObservableFeature()+"' ");	
		sb.append("valueCode='" + getValueCode()+"' ");	
		sb.append("definition='" + getDefinition()+"' ");	
		sb.append("isMissing='" + getIsMissing()+"'");	
		sb.append(");");
		return sb.toString();
	}

	@Override
	public Integer getIdValue()
	{
		return getId();
	}		
	

	@Override
	public Iterable<String> getAttributeNames()
	{
		Set<String> attributeNames = new LinkedHashSet<String>();
		for (AttributeMetaData attr : new CategoryMetaData().getAttributes())
		{
			attributeNames.add(attr.getName());
		}

		return attributeNames;
	}
	
	@Override
	public java.util.List<String> getLabelAttributeNames()
	{
		java.util.List<String> result = new java.util.ArrayList<String>();
		result.add("Identifier");
		return result;
	}

	@Override
	public void set(String attributeName, Object value)
	{
		set(new MapEntity(attributeName, value), false);
	}

	@Override
	public boolean equals(Object obj)
	{
		if (this == obj) return true;
		if (obj == null) return false;
		if (!super.equals(obj)) return false;
		if (getClass() != obj.getClass()) return false;
		return true;
	}
	
	@Override
	public int hashCode()
	{
		int result = super.hashCode();
		return result;
	}
	
	@Override
	public org.molgenis.data.EntityMetaData getEntityMetaData()
	{
		return new CategoryMetaData();
	}
}
